
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Notification_recordsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const notification_records = await db.notification_records.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        approved_at: data.approved_at
        ||
        null
            ,
            
        record_hash: data.record_hash
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await notification_records.setContract_folder( data.contract_folder || null, {
            transaction,
        });
        
        await notification_records.setContract_participant( data.contract_participant || null, {
            transaction,
        });
        
        await notification_records.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.notification_records.getTableName(),
                belongsToColumn: 'record_pdf',
                belongsToId: notification_records.id,
            },
            data.record_pdf,
            options,
        );
        

        return notification_records;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const notification_recordsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                approved_at: item.approved_at
            ||
            null
            ,
            
                record_hash: item.record_hash
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const notification_records = await db.notification_records.bulkCreate(notification_recordsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < notification_records.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.notification_records.getTableName(),
                    belongsToColumn: 'record_pdf',
                    belongsToId: notification_records[i].id,
                },
                data[i].record_pdf,
                options,
            );
        }
        

        return notification_records;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const notification_records = await db.notification_records.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.approved_at !== undefined) updatePayload.approved_at = data.approved_at;
        
        
        if (data.record_hash !== undefined) updatePayload.record_hash = data.record_hash;
        
        
        updatePayload.updatedById = currentUser.id;

        await notification_records.update(updatePayload, {transaction});

        
        
        if (data.contract_folder !== undefined) {
            await notification_records.setContract_folder(
              
              data.contract_folder,
              
              { transaction }
            );
        }
        
        if (data.contract_participant !== undefined) {
            await notification_records.setContract_participant(
              
              data.contract_participant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await notification_records.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.notification_records.getTableName(),
                belongsToColumn: 'record_pdf',
                belongsToId: notification_records.id,
            },
            data.record_pdf,
            options,
        );
        

        return notification_records;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const notification_records = await db.notification_records.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of notification_records) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of notification_records) {
                await record.destroy({transaction});
            }
        });


        return notification_records;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const notification_records = await db.notification_records.findByPk(id, options);

        await notification_records.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await notification_records.destroy({
            transaction
        });

        return notification_records;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const notification_records = await db.notification_records.findOne(
            { where },
            { transaction },
        );

        if (!notification_records) {
            return notification_records;
        }

        const output = notification_records.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.notification_record_items_notification_record = await notification_records.getNotification_record_items_notification_record({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.contract_folder = await notification_records.getContract_folder({
            transaction
        });
        
        
        output.contract_participant = await notification_records.getContract_participant({
            transaction
        });
        
        
        output.record_pdf = await notification_records.getRecord_pdf({
            transaction
        });
        
        
        output.organizations = await notification_records.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.contract_folders,
        as: 'contract_folder',
        
        where: filter.contract_folder ? {
          [Op.or]: [
            { id: { [Op.in]: filter.contract_folder.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.contract_folder.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.contract_participants,
        as: 'contract_participant',
        
        where: filter.contract_participant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.contract_participant.split('|').map(term => Utils.uuid(term)) } },
            {
              display_name: {
                [Op.or]: filter.contract_participant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'record_pdf',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.record_hash) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notification_records',
                        'record_hash',
                        filter.record_hash,
                    ),
                };
            }
            

            
            

            
            if (filter.approved_atRange) {
                const [start, end] = filter.approved_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    approved_at: {
                    ...where.approved_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    approved_at: {
                    ...where.approved_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.notification_records.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'notification_records',
                        'record_hash',
                        query,
                    ),
                ],
            };
        }

        const records = await db.notification_records.findAll({
            attributes: [ 'id', 'record_hash' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['record_hash', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.record_hash,
        }));
    }

    
};

